---
title: AudioParam.setValueCurveAtTime()
slug: Web/API/AudioParam/setValueCurveAtTime
tags:
  - API
  - Audio
  - AudioParam
  - Method
  - Reference
  - Web
  - Web Audio
  - Web Audio API
  - setValueCurveAtTime
---
<p>{{APIRef("Web Audio API")}}</p>

<p class="summary"><span class="seoSummary">The <strong><code>setValueCurveAtTime()</code></strong> method of the {{domxref("AudioParam")}} interface schedules the parameter's value to change following a curve defined by a list of values.</span> The curve is a linear interpolation between the sequence of values defined in an array of floating-point values, which are scaled to fit into the given interval starting at <code>startTime</code> and a specific duration.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>paramRef</em> = <em>param</em>.setValueCurveAtTime(<em>values</em>, <em>startTime</em>, <em>duration</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>values</code></dt>
 <dd>An array of floating-point numbers representing the value curve the {{domxref("AudioParam")}} will change through along the specified <code>duration</code>. Every value in the array must be a finite number; if any value is <code>NaN</code>, <code>Infinity</code>, or <code>-Infinity</code>, a <code>TypeError</code> exception is thrown.</dd>
 <dt><code>startTime</code></dt>
 <dd>A double representing the time (in seconds) after the {{ domxref("AudioContext") }} was first created that the change in value will happen. If this value is lower than {{domxref("AudioContext.currentTime")}}, it is clamped to <code>currentTime</code>.</dd>
 <dt><code>duration</code></dt>
 <dd>A double representing the total time (in seconds) over which the parameter's <code>value</code> will change following the specified curve. The specified values are spaced equally along this duration.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A reference to this <code>AudioParam</code> object. Some older browser implementations of this interface return <code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>The specified array of <code>values</code> has fewer than 2 items in it.</dd>
 <dt><code>RangeError</code></dt>
 <dd>The specified <code>startTime</code> is either negative or a non-finite value, or <code>duration</code> is not a finite, strictly positive number.</dd>
 <dt><code>TypeError</code></dt>
 <dd>One or more of the values in the <code>values</code> array is non-finite. Non-finite values are <code>NaN</code>, <code>Infinity</code>, and <code>-Infinity</code>.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>When the parameter's value finishes following the curve, its value is guaranteed to match the last value in the set of values specified in the <code>values</code> parameter.</p>

<div class="note">
<p><strong>Note:</strong> Some early implementations of the Web Audio API did not ensure this to be the case, causing unexpected results.</p>
</div>

<h2 id="Examples">Examples</h2>

<p>In this example, we have a media source with a single button (see the <a class="external external-icon" href="https://github.com/mdn/webaudio-examples/blob/master/audio-param/index.html">webaudio-examples repo</a> for the source code, or <a class="external external-icon" href="https://mdn.github.io/webaudio-examples/audio-param/">view the example live</a>.) When this button is pressed, <code>setValueCurveAtTime()</code> is used to change the gain value between the values contained in the waveArray array:</p>

<pre class="brush: js;highlight[42]">// create audio context
var AudioContext = window.AudioContext || window.webkitAudioContext;
var audioCtx = new AudioContext();

// set basic variables for example
var myAudio = document.querySelector('audio');
var pre = document.querySelector('pre');
var myScript = document.querySelector('script');

pre.innerHTML = myScript.innerHTML;

var valueCurve = document.querySelector('.value-curve');

// Create a MediaElementAudioSourceNode
// Feed the HTMLMediaElement into it
var source = audioCtx.createMediaElementSource(myAudio);

// Create a gain node and set it's gain value to 0.5
var gainNode = audioCtx.createGain();
gainNode.gain.value = 0.5;
var currGain = gainNode.gain.value;

// connect the AudioBufferSourceNode to the gainNode
// and the gainNode to the destination
source.connect(gainNode);
gainNode.connect(audioCtx.destination);

// set button to do something onclick

var waveArray = new Float32Array(9);
waveArray[0] = 0.5;
waveArray[1] = 1;
waveArray[2] = 0.5;
waveArray[3] = 0;
waveArray[4] = 0.5;
waveArray[5] = 1;
waveArray[6] = 0.5;
waveArray[7] = 0;
waveArray[8] = 0.5;

valueCurve.onclick = function() {
  gainNode.gain.setValueCurveAtTime(waveArray, audioCtx.currentTime, 2);
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audioparam-setvaluecurveattime', 'setValueCurveAtTime')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.AudioParam.setValueCurveAtTime")}}</p>

<p>Versions before Chrome 46 use nearest neighbor instead of linear interpolation.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
